//=============================================================================
//  model view control controller
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.1.0
// Log     :
//=============================================================================
// 22.02.2001 building class
//============================================================================
// to do   :
//=============================================================================

#include <gtk/gtk.h>
#include <stdio.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mvcHeader.h>
#include <mcSequence.h>
#include <mcStatics.h>

class TMvcController: public TMvcBase
{
  private:
    GtkWidget* fWidget;                               // main widget
    TMidiSequence* fSequence;                         // last displayed sequence
    TMvcHeader* fHeader;                              // header of view
    GtkWidget* drwControllerMain;                     // most used widget

    int fWidth;                                       // width of drawing area
    int fHeight;                                      // height of drawing area
    int fWindowWidth;                                 // width of window

    float fTicksPerPix;                               // midi ticks per pixel on screen
    long fMeasureCount;                               // measure count for x-axis
    bool fSelectionActive;                            // selection in progress

    GdkColor* colBackground;                          // background color
    GdkColor* colGrid;                                // color of grid
    GdkColor* colSubGrid;                             // color of subgrid
    GdkColor* colMidi;                                // midi event color
    GdkColor* colSelection;                           // selection color

    GdkPixmap* fBufferMain;                           // pixmap buffer for controller
    GdkPixmap* fBufferLabel; 			                    // pixmap buffer for label

    GtkAdjustment* fXAdjustment;                      // time scroll adjustment

                                                      // read offset on grid
    long GetOffsetOnGrid( long aOffset, bool aRoundDown );
  public:
                                                      // constructor
    TMvcController( GtkWidget* aWidget, TMidiSequence* aSequence );
    GtkWidget* GetWidget( void );                     // read widget

    void Resize( void );                              // set new with and height
		void Scroll( void );															// scroll window

                                                      // draw in main area
    bool ControllerExpose( GtkWidget* aWidget, GdkEventExpose* aEvent );
                                                      // draw header area
    void MCMessage( TMidiBase* aMidiBase, sMCMessage* aMCMessage );

    void MouseDown( long x );                         // mouse events
    void MouseUp( long x );
    void MouseMove( long x );

};