//=============================================================================
//  model view control Track properties
//=============================================================================
#include <mvcTrackProperties.h>
#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mcStatics.h>

// callbacks
void OkClickedTrackProp( GtkButton *button, gpointer user_data );
void CancelClickedTrackProp( GtkButton *button, gpointer user_data );

//=============================================================================
// construtor MvcTrackProperties											27.03.2000 Adrian Meyer
//=============================================================================
TMvcTrackProperties::TMvcTrackProperties( TMidiTrack* aTrack )
{
  wndTrackProperties = create_wndTrackProperties();		// call glade
	AddChildrenToWidgetList( wndTrackProperties );      // fetch widgets
	fTrack = aTrack;
	
  HookSignal( "btnOk", "clicked", GTK_SIGNAL_FUNC( OkClickedTrackProp ), this );
  HookSignal( "btnCancel", "clicked", GTK_SIGNAL_FUNC( CancelClickedTrackProp ), this );

	char tmpStr[100];
	char* tmpItem = new char[ strlen("[none]")];				// no patch set

	fGMPatchNames = NULL;
	strcpy( tmpItem, "[none]" );
	fGMPatchNames = g_list_append( fGMPatchNames, tmpItem );

	for ( int i = 0; i<128; i++ )												// add only numbers
	{
		sprintf( tmpStr, "[%.3d] %s", i+1, cGMPatchName[ i ]);
//		strcat( tmpStr,  );
		char* tmpItem = new char[ strlen(tmpStr) + 1 ];
		strcpy( tmpItem, tmpStr );
		fGMPatchNames = g_list_append( fGMPatchNames, tmpItem );
	}

	gtk_combo_set_popdown_strings( GTK_COMBO( FindWidget( "cboInstrumentPatch" )), fGMPatchNames );	

	if ( aTrack == 0 ) return;

  gtk_widget_show( wndTrackProperties );							

	SetData();																					// set data to gui
}

//=============================================================================
// destrutor MvcMain						 											27.03.2000 Adrian Meyer
//=============================================================================
TMvcTrackProperties::~TMvcTrackProperties( void )
{
	delete wndTrackProperties;
}

//=============================================================================
// set data to gui																		27.03.2000 Adrian Meyer
//=============================================================================
void TMvcTrackProperties::SetData( void )
{
	char* tmpTrackName = new char[ strlen( fTrack->GetTrackName()) + 1 ];
	strcpy( tmpTrackName, fTrack->GetTrackName() );
	gtk_entry_set_text( GTK_ENTRY( FindWidget( "edtTrackName" )),
		tmpTrackName);

	char* tmpInstrumentName = new char[ strlen( fTrack->GetInstrumentName()) + 1 ];
	strcpy( tmpInstrumentName, fTrack->GetInstrumentName() );
	gtk_entry_set_text( GTK_ENTRY( FindWidget( "edtInstrumentName" )),
		tmpInstrumentName );

  gtk_spin_button_set_value( GTK_SPIN_BUTTON( FindWidget( "spiChannel" )),
		fTrack->GetChannel() );

  char* tmpStr = new char[200];

	strcpy( tmpStr, "[none]" );

	if ( fTrack->GetInstrumentPatch() > -1 )
	{
		sprintf( tmpStr, "[%.3d] %s", fTrack->GetInstrumentPatch() + 1,
				cGMPatchName[fTrack->GetInstrumentPatch()] );
	}

	gtk_entry_set_text( (GtkEntry*)FindWidget( "edtInstrumentPatch" ), tmpStr );

	delete tmpStr;
}

//=============================================================================
// read data from gui into object											27.03.2000 Adrian Meyer
//=============================================================================
void TMvcTrackProperties::GetData( void )
{
	fTrack->SetTrackName(
		gtk_entry_get_text( GTK_ENTRY( FindWidget( "edtTrackName" ))));

	fTrack->SetInstrumentName(
		gtk_entry_get_text( GTK_ENTRY( FindWidget( "edtInstrumentName" ))));

	fTrack->SetChannel(
	  gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON( FindWidget( "spiChannel" ))));

  short tmpInstrumentPatch = -1;											// set instrument patch
	for ( unsigned int i = 0; i < g_list_length( fGMPatchNames ); i++ )
	{
		if ( strcmp( (char*)g_list_nth_data( fGMPatchNames, i ),
			gtk_entry_get_text((GtkEntry*)FindWidget( "edtInstrumentPatch" ))) == 0 )
		{
			tmpInstrumentPatch = i-1;
		}					
	}

	fTrack->SetInstrumentPatch( tmpInstrumentPatch );
}

//=============================================================================
// read widget																				27.03.2000 Adrian Meyer
//=============================================================================
GtkWidget* TMvcTrackProperties::GetWidget( void )
{
	return wndTrackProperties;
}

//=============================================================================
// ok clicked																					27.03.2000 Adrian Meyer
//=============================================================================
void OkClickedTrackProp( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( ((TMvcTrackProperties*)user_data)->GetWidget() );
	((TMvcTrackProperties*)user_data)->GetData();
}

//=============================================================================
// cancel clicked																			27.03.2000 Adrian Meyer
//=============================================================================
void CancelClickedTrackProp( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( ((TMvcTrackProperties*)user_data)->GetWidget() );
}